/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/10/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.JenisProfileDto;
import com.portofolio.service.JenisProfileService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;

@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/jenisProfile")
public class JenisProfileController extends LocaleController {
	@Lazy
	@Autowired
	private JenisProfileService jenisProfileService;

	
	@ApiOperation("Api Untuk Menyimpan JenisProfile")
	@PostMapping("/save")
	public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody JenisProfileDto entity, HttpServletRequest request) {
		Map<String, Object> result = jenisProfileService.save(entity);
		return RestUtil.getJsonResponse(result);
	}

	
	@ApiOperation("Api Untuk Update JenisProfile")
	@PutMapping("/update")
	public ResponseEntity<Map<String, Object>> update(
			@RequestParam(value = "kdJenisProfile", required = true) Integer kdJenisProfile,
			@RequestParam(value = "version", required = true) Integer version,
			@Valid @RequestBody JenisProfileDto jenisProfileDto, HttpServletRequest request) {
		Map<String, Object> result = jenisProfileService.update(jenisProfileDto, kdJenisProfile, version);
		return RestUtil.getJsonResponse(result);
	}

	
	@ApiOperation("Api Untuk Menghapus JenisProfile BerdasarkanKdJenisProfile")
	@DeleteMapping("/delete")
	public ResponseEntity<Map<String, Object>> deleteById(
			@RequestParam(value = "kdJenisProfile", required = true) Integer kdJenisProfile,
			@RequestParam(value = "version", required = true) Integer version) {
		Map<String, Object> result = jenisProfileService.deleteByKdJenisProfile(kdJenisProfile,version);
		return RestUtil.getJsonResponse(result);
	}

	
	@ApiOperation("Api Untuk Menampilkan Semua JenisProfile")
	@GetMapping("/grid")
	public ResponseEntity<Map<String, Object>> grid(@RequestParam(value = "page", defaultValue = "1") Integer page,
			@RequestParam(value = "rows", defaultValue = "10") Integer rows,
			@RequestParam(value = "dir", defaultValue = "namaJenisProfile") String dir,
			@RequestParam(value = "sort", defaultValue = "desc") String sort,
			@RequestParam(value = "namaJenisProfile", required = false) String namaJenisProfile,
			@RequestParam(value = "statusEnabled", required = true) boolean statusEnabled) {
		Map<String, Object> result = jenisProfileService.grid(page, rows, sort, dir, namaJenisProfile,statusEnabled);
		return RestUtil.getJsonResponse(result);
	}

	
	@ApiOperation("Api Untuk Menampilkan JenisProfile Berdasarkan kode")
	@GetMapping("/findByKdJenisProfile")
	public ResponseEntity<Map<String, Object>> findByJenisProfile(@RequestParam(value = "kdJenisProfile", required = true) Integer kdJenisProfile) {
		Map<String, Object> result = jenisProfileService.findByKdJenisProfile(kdJenisProfile);
		return RestUtil.getJsonResponse(result);
	}

}
